FilterChain (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types, class: FilterChain

# Class FilterChain

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.FilterChain

All Implemented Interfaces:
  `Cloneable`

Direct Known Subclasses:
  `FilterMapper`

public class FilterChain extends DataType
FilterChain may contain a chained set of filter readers.

- ## Field Summary

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `FilterChain()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `add(ChainableReader filter)`
  Add a chainfilter filter.
  `void`
  `addClassConstants(ClassConstants classConstants)`
  Add a ClassConstants filter.
  `void`
  `addContainsRegex(TokenFilter.ContainsRegex filter)`
  Add a containsregex filter.
  `void`
  `addDeleteCharacters(TokenFilter.DeleteCharacters filter)`
  Add a delete characters filter.
  `void`
  `addEscapeUnicode(EscapeUnicode escapeUnicode)`
  Add an EscapeUnicode filter.
  `void`
  `addExpandProperties(ExpandProperties expandProperties)`
  Add an ExpandProperties filter.
  `void`
  `addFilterReader(AntFilterReader filterReader)`
  Add an AntFilterReader filter.
  `void`
  `addHeadFilter(HeadFilter headFilter)`
  Add a HeadFilter filter.
  `void`
  `addIgnoreBlank(TokenFilter.IgnoreBlank filter)`
  Add an ignoreBlank filter.
  `void`
  `addLineContains(LineContains lineContains)`
  Add a LineContains filter.
  `void`
  `addLineContainsRegExp(LineContainsRegExp lineContainsRegExp)`
  Add a LineContainsRegExp filter.
  `void`
  `addPrefixLines(PrefixLines prefixLines)`
  Add a PrefixLines filter.
  `void`
  `addReplaceRegex(TokenFilter.ReplaceRegex filter)`
  Add a replaceregex filter.
  `void`
  `addReplaceString(TokenFilter.ReplaceString filter)`
  Add a replacestring filter.
  `void`
  `addReplaceTokens(ReplaceTokens replaceTokens)`
  Add a ReplaceTokens filter.
  `void`
  `addStripJavaComments(StripJavaComments stripJavaComments)`
  Add a StripJavaCommands filter.
  `void`
  `addStripLineBreaks(StripLineBreaks stripLineBreaks)`
  Add a StripLineBreaks filter.
  `void`
  `addStripLineComments(StripLineComments stripLineComments)`
  Add a StripLineComments filter.
  `void`
  `addSuffixLines(SuffixLines suffixLines)`
  Add a SuffixLines filter.
  `void`
  `addTabsToSpaces(TabsToSpaces tabsToSpaces)`
  Add a TabsToSpaces filter.
  `void`
  `addTailFilter(TailFilter tailFilter)`
  Add a TailFilter filter.
  `void`
  `addTokenFilter(TokenFilter tokenFilter)`
  Add a TokenFilter filter.
  `void`
  `addTrim(TokenFilter.Trim filter)`
  Add a trim filter.
  `protected void`
  `dieOnCircularReference(Stack<Object> stk, Project p)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `Vector<Object>`
  `getFilterReaders()`
  Return the filters.
  `void`
  `setRefid(Reference r)`
  Makes this instance in effect a reference to another FilterChain instance.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, clone, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes, toString`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `Object`
  `clone()`
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.
  `String`
  `toString()`
  Basic DataType toString().

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### FilterChain

    public FilterChain()

- ## Method Details

  - ### addFilterReader

    public void addFilterReader(AntFilterReader filterReader)
    Add an AntFilterReader filter.
    Parameters:
      `filterReader` - an `AntFilterReader` value

  - ### getFilterReaders

    public Vector<Object> getFilterReaders()
    Return the filters.
    Returns:
      a `Vector` value containing the filters

  - ### addClassConstants

    public void addClassConstants(ClassConstants classConstants)
    Add a ClassConstants filter.
    Parameters:
      `classConstants` - a `ClassConstants` value

  - ### addExpandProperties

    public void addExpandProperties(ExpandProperties expandProperties)
    Add an ExpandProperties filter.
    Parameters:
      `expandProperties` - an `ExpandProperties` value

  - ### addHeadFilter

    public void addHeadFilter(HeadFilter headFilter)
    Add a HeadFilter filter.
    Parameters:
      `headFilter` - a `HeadFilter` value

  - ### addLineContains

    public void addLineContains(LineContains lineContains)
    Add a LineContains filter.
    Parameters:
      `lineContains` - a `LineContains` value

  - ### addLineContainsRegExp

    public void addLineContainsRegExp(LineContainsRegExp lineContainsRegExp)
    Add a LineContainsRegExp filter.
    Parameters:
      `lineContainsRegExp` - a `LineContainsRegExp` value

  - ### addPrefixLines

    public void addPrefixLines(PrefixLines prefixLines)
    Add a PrefixLines filter.
    Parameters:
      `prefixLines` - a `PrefixLines` value

  - ### addSuffixLines

    public void addSuffixLines(SuffixLines suffixLines)
    Add a SuffixLines filter.
    Parameters:
      `suffixLines` - a `SuffixLines` value
    Since:
      Ant 1.8.0

  - ### addReplaceTokens

    public void addReplaceTokens(ReplaceTokens replaceTokens)
    Add a ReplaceTokens filter.
    Parameters:
      `replaceTokens` - a `ReplaceTokens` value

  - ### addStripJavaComments

    public void addStripJavaComments(StripJavaComments stripJavaComments)
    Add a StripJavaCommands filter.
    Parameters:
      `stripJavaComments` - a `StripJavaComments` value

  - ### addStripLineBreaks

    public void addStripLineBreaks(StripLineBreaks stripLineBreaks)
    Add a StripLineBreaks filter.
    Parameters:
      `stripLineBreaks` - a `StripLineBreaks` value

  - ### addStripLineComments

    public void addStripLineComments(StripLineComments stripLineComments)
    Add a StripLineComments filter.
    Parameters:
      `stripLineComments` - a `StripLineComments` value

  - ### addTabsToSpaces

    public void addTabsToSpaces(TabsToSpaces tabsToSpaces)
    Add a TabsToSpaces filter.
    Parameters:
      `tabsToSpaces` - a `TabsToSpaces` value

  - ### addTailFilter

    public void addTailFilter(TailFilter tailFilter)
    Add a TailFilter filter.
    Parameters:
      `tailFilter` - a `TailFilter` value

  - ### addEscapeUnicode

    public void addEscapeUnicode(EscapeUnicode escapeUnicode)
    Add an EscapeUnicode filter.
    Parameters:
      `escapeUnicode` - an `EscapeUnicode` value
    Since:
      Ant 1.6

  - ### addTokenFilter

    public void addTokenFilter(TokenFilter tokenFilter)
    Add a TokenFilter filter.
    Parameters:
      `tokenFilter` - a `TokenFilter` value
    Since:
      Ant 1.6

  - ### addDeleteCharacters

    public void addDeleteCharacters(TokenFilter.DeleteCharacters filter)
    Add a delete characters filter.
    Parameters:
      `filter` - a `TokenFilter.DeleteCharacters` value
    Since:
      Ant 1.6

  - ### addContainsRegex

    public void addContainsRegex(TokenFilter.ContainsRegex filter)
    Add a containsregex filter.
    Parameters:
      `filter` - a `TokenFilter.ContainsRegex` value
    Since:
      Ant 1.6

  - ### addReplaceRegex

    public void addReplaceRegex(TokenFilter.ReplaceRegex filter)
    Add a replaceregex filter.
    Parameters:
      `filter` - a `TokenFilter.ReplaceRegex` value

  - ### addTrim

    public void addTrim(TokenFilter.Trim filter)
    Add a trim filter.
    Parameters:
      `filter` - a `TokenFilter.Trim` value
    Since:
      Ant 1.6

  - ### addReplaceString

    public void addReplaceString(TokenFilter.ReplaceString filter)
    Add a replacestring filter.
    Parameters:
      `filter` - a `TokenFilter.ReplaceString` value
    Since:
      Ant 1.6

  - ### addIgnoreBlank

    public void addIgnoreBlank(TokenFilter.IgnoreBlank filter)
    Add an ignoreBlank filter.
    Parameters:
      `filter` - a `TokenFilter.IgnoreBlank` value
    Since:
      Ant 1.6

  - ### setRefid

    public void setRefid(Reference r) throws BuildException
    Makes this instance in effect a reference to another FilterChain instance.

    You must not set another attribute or nest elements inside this element if you make it a reference.

    Overrides:
      `setRefid` in class `DataType`
    Parameters:
      `r` - the reference to which this instance is associated
    Throws:
      `BuildException` - if this instance already has been configured.

  - ### add

    public void add(ChainableReader filter)
    Add a chainfilter filter.
    Parameters:
      `filter` - a `ChainableReader` value
    Since:
      Ant 1.6

  - ### dieOnCircularReference

    protected void dieOnCircularReference(Stack<Object> stk, Project p) throws BuildException
    Description copied from class: `DataType`
    Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

    If one is included, throw a BuildException created by `circularReference`.

    This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

    The general contract of this method is that it shouldn't do anything if `DataType.checked` is true and set it to true on exit.

    Overrides:
      `dieOnCircularReference` in class `DataType`
    Parameters:
      `stk` - the stack of references to check.
      `p` - the project to use to dereference the references.
    Throws:
      `BuildException` - on error.